IF EXISTS (SELECT name FROM master.dbo.sysdatabases WHERE name = N'zbit_net_chat')
BEGIN
	DROP DATABASE [zbit_net_chat]
	--IF EXISTS (SELECT name FROM master.dbo.sysdatabases WHERE name = N'zbit_net_chat_old')
	--	DROP DATABASE [zbit_net_chat_old]
	--EXEC sp_renamedb 'zbit_net_chat','zbit_net_chat_old'
END
GO

CREATE DATABASE [zbit_net_chat]  COLLATE SQL_Latin1_General_CP1_CI_AS
GO

--if( ( (@@microsoftversion / power(2, 24) = 8) and (@@microsoftversion & 0xffff >= 724) ) or ( (@@microsoftversion / power(2, 24) = 7) and (@@microsoftversion & 0xffff >= 1082) ) )
--	exec sp_dboption N'zbit_net_chat', N'db chaining', N'false'
--GO

use [zbit_net_chat]
GO

if not exists (select * from master.dbo.syslogins where loginname = N'zbc_user')
BEGIN
	declare @logindb nvarchar(132), @loginlang nvarchar(132) select @logindb = N'zbit_net_chat', @loginlang = N'us_english'
	if @logindb is null or not exists (select * from master.dbo.sysdatabases where name = @logindb)
		select @logindb = N'master'
	if @loginlang is null or (not exists (select * from master.dbo.syslanguages where name = @loginlang) and @loginlang <> N'us_english')
		select @loginlang = @@language
	exec sp_addlogin N'zbc_user', 'zbcpwd', @logindb, @loginlang
END
GO
if not exists (select * from dbo.sysusers where name = N'zbc_user' and uid < 16382)
	EXEC sp_grantdbaccess N'zbc_user', N'zbc_user'
GO
exec sp_addrolemember N'db_owner', N'zbc_user'
GO


/*
 *************************************************************************************************************
 *	If don't want to create additional database and additional sql lognin for the chat start scrip from here *
 *************************************************************************************************************
 */
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_abusivewords_site]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[zbc_abusivewords] DROP CONSTRAINT FK_abusivewords_site
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_bannedips_site]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[zbc_bannedips] DROP CONSTRAINT FK_bannedips_site
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_bannedlogins_site]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[zbc_bannedlogins] DROP CONSTRAINT FK_bannedlogins_site
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_restrictednames_site]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[zbc_restrictednames] DROP CONSTRAINT FK_restrictednames_site
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_room_site]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[zbc_room] DROP CONSTRAINT FK_room_site
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_storedmessages_site]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[zbc_storedmessages] DROP CONSTRAINT FK_storedmessages_site
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_urlpatterns_site]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[zbc_urlpatterns] DROP CONSTRAINT FK_urlpatterns_site
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_abusivewords_delete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_abusivewords_delete]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_abusivewords_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_abusivewords_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_abusivewords_insert]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_abusivewords_insert]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_abusivewords_update]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_abusivewords_update]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_abusivewordsall_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_abusivewordsall_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_bannedips_delete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_bannedips_delete]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_bannedips_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_bannedips_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_bannedips_insert]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_bannedips_insert]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_bannedips_update]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_bannedips_update]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_bannedipsall_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_bannedipsall_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_bannedlogins_delete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_bannedlogins_delete]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_bannedlogins_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_bannedlogins_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_bannedlogins_insert]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_bannedlogins_insert]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_bannedlogins_update]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_bannedlogins_update]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_bannedloginsall_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_bannedloginsall_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_restrictednames_delete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_restrictednames_delete]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_restrictednames_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_restrictednames_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_restrictednames_insert]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_restrictednames_insert]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_restrictednames_update]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_restrictednames_update]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_restrictednamesall_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_restrictednamesall_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_room_delete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_room_delete]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_room_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_room_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_room_insert]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_room_insert]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_room_update]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_room_update]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_siterooms_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_siterooms_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_storedmessages_delete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_storedmessages_delete]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_storedmessages_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_storedmessages_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_storedmessages_insert]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_storedmessages_insert]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_storedmessages_update]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_storedmessages_update]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_storedmessagesall_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_storedmessagesall_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_urlpatterns_delete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_urlpatterns_delete]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_urlpatterns_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_urlpatterns_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_urlpatterns_insert]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_urlpatterns_insert]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_urlpatterns_update]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_urlpatterns_update]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_urlpatternsall_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_urlpatternsall_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_chat_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_chat_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_config_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_config_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_config_update]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_config_update]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_messages_insert]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_messages_insert]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_messages_delete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_messages_delete]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_site_delete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_site_delete]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_site_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_site_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_site_insert]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_site_insert]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_site_update]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_site_update]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_sites_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_sites_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_siteusers_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_siteusers_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_user_delete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_user_delete]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_user_get]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_user_get]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_user_insert]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_user_insert]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_user_update]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[zbc_user_update]
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_abusivewords]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[zbc_abusivewords]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_bannedips]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[zbc_bannedips]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_bannedlogins]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[zbc_bannedlogins]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_restrictednames]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[zbc_restrictednames]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_room]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[zbc_room]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_storedmessages]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[zbc_storedmessages]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_urlpatterns]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[zbc_urlpatterns]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_chat]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[zbc_chat]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_config]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[zbc_config]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_msg]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[zbc_msg]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_site]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[zbc_site]
GO
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[zbc_user]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[zbc_user]
GO

/*
 ******************************************************************************************************************
 * This is where we start to create database elements. If you don't want the script to drop any thing, start here *
 ******************************************************************************************************************
 */

CREATE TABLE [dbo].[zbc_chat] (
	[chat_id] [int] NOT NULL ,
	[sulogin_id] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO
CREATE TABLE [dbo].[zbc_config] (
	[config_name] [varchar] (250) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[config_value] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[read_only] [bit] NOT NULL ,
	[comment] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
GO
CREATE TABLE [dbo].[zbc_msg] (
	[site_id] [int] ,
	[site_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS,
	[room_id] [int] ,
	[room_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS ,
	[msg_text] [text] COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[msg_date] [datetime] NOT NULL ,
	[from_user] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[to_user] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS,
	[from_ip] [varchar] (64) COLLATE SQL_Latin1_General_CP1_CI_AS
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
CREATE TABLE [dbo].[zbc_site] (
	[site_id] [int] NOT NULL ,
	[site_name] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[MaxNumberOfUsers] [int] NULL ,
	[MaxNumberOfRooms] [int] NULL ,
	[MaxRoomNameLength] [int] NULL ,
	[MinMsgInterval] [int] NULL ,
	[MaxNumberOfUsersRooms] [int] NULL ,
	[HTTPPattern] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Flags] [int] NOT NULL
) ON [PRIMARY]
GO
CREATE TABLE [dbo].[zbc_user] (
	[login_id] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[login_psw] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[site_id] [int] NOT NULL ,
	[fname] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[lname] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[email] [varchar] (80) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[address] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[age] [int] NOT NULL ,
	[user_type] [int] NOT NULL ,
	[allow_profile] [bit] NOT NULL ,
	[gender]	[char] (1) NULL ,
	[custom] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
) ON [PRIMARY]
GO
CREATE TABLE [dbo].[zbc_abusivewords] (
	[word] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[site_id] [int] NOT NULL 
) ON [PRIMARY]
GO
CREATE TABLE [dbo].[zbc_bannedips] (
	[bannedip] [varchar] (15) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[site_id] [int] NOT NULL 
) ON [PRIMARY]
GO
CREATE TABLE [dbo].[zbc_bannedlogins] (
	[bannedlogin] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[site_id] [int] NOT NULL 
) ON [PRIMARY]
GO
CREATE TABLE [dbo].[zbc_restrictednames] (
	[word] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[site_id] [int] NOT NULL 
) ON [PRIMARY]
GO
CREATE TABLE [dbo].[zbc_room] (
	[room_id] [int] NOT NULL ,
	[room_name] [varchar] (80) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[room_topic] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[room_owner] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[private] [bit] NOT NULL ,
	[moderator] [bit] NOT NULL ,
	[site_id] [int] NOT NULL 
) ON [PRIMARY]
GO
CREATE TABLE [dbo].[zbc_storedmessages] (
	[msg] [varchar] (850) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[site_id] [int] NOT NULL 
) ON [PRIMARY]
GO
CREATE TABLE [dbo].[zbc_urlpatterns] (
	[pattern] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[site_id] [int] NOT NULL 
) ON [PRIMARY]
GO


ALTER TABLE [dbo].[zbc_chat] WITH NOCHECK ADD 
	CONSTRAINT [PK_chat] PRIMARY KEY  CLUSTERED 
	(
		[chat_id],
		[sulogin_id]
	)  ON [PRIMARY] 
GO
ALTER TABLE [dbo].[zbc_config] WITH NOCHECK ADD 
	CONSTRAINT [PK_config] PRIMARY KEY  CLUSTERED 
	(
		[config_name]
	)  ON [PRIMARY] 
GO
ALTER TABLE [dbo].[zbc_site] WITH NOCHECK ADD 
	CONSTRAINT [PK_site] PRIMARY KEY  CLUSTERED 
	(
		[site_id]
	)  ON [PRIMARY] 
GO
ALTER TABLE [dbo].[zbc_user] WITH NOCHECK ADD 
	CONSTRAINT [PK_zbc_user] PRIMARY KEY  CLUSTERED 
	(
		[login_id],
		[site_id]
	)  ON [PRIMARY] 
GO
ALTER TABLE [dbo].[zbc_abusivewords] WITH NOCHECK ADD 
	CONSTRAINT [PK_abusivewords] PRIMARY KEY  CLUSTERED 
	(
		[word],
		[site_id]
	)  ON [PRIMARY] 
GO
ALTER TABLE [dbo].[zbc_bannedips] WITH NOCHECK ADD 
	CONSTRAINT [PK_bannedips] PRIMARY KEY  CLUSTERED 
	(
		[bannedip],
		[site_id]
	)  ON [PRIMARY] 
GO
ALTER TABLE [dbo].[zbc_bannedlogins] WITH NOCHECK ADD 
	CONSTRAINT [PK_bannedlogins] PRIMARY KEY  CLUSTERED 
	(
		[bannedlogin],
		[site_id]
	)  ON [PRIMARY] 
GO
ALTER TABLE [dbo].[zbc_restrictednames] WITH NOCHECK ADD 
	CONSTRAINT [PK_restrictednames] PRIMARY KEY  CLUSTERED 
	(
		[word],
		[site_id]
	)  ON [PRIMARY] 
GO
ALTER TABLE [dbo].[zbc_room] WITH NOCHECK ADD 
	CONSTRAINT [PK_room] PRIMARY KEY  CLUSTERED 
	(
		[room_id]
	)  ON [PRIMARY] 
GO
ALTER TABLE [dbo].[zbc_storedmessages] WITH NOCHECK ADD 
	CONSTRAINT [PK_storedmessages] PRIMARY KEY  CLUSTERED 
	(
		[msg],
		[site_id]
	)  ON [PRIMARY] 
GO
ALTER TABLE [dbo].[zbc_urlpatterns] WITH NOCHECK ADD 
	CONSTRAINT [PK_urlpatterns] PRIMARY KEY  CLUSTERED 
	(
		[pattern],
		[site_id]
	)  ON [PRIMARY] 
GO


ALTER TABLE [dbo].[zbc_msg] ADD 
	CONSTRAINT [DF_msg_msg_date] DEFAULT (getdate()) FOR [msg_date]
GO
/*
ALTER TABLE [dbo].[abusivewords] ADD 
	CONSTRAINT [FK_abusivewords_site] FOREIGN KEY 
	(
		[site_id]
	) REFERENCES [dbo].[site] (
		[site_id]
	)

ALTER TABLE [dbo].[bannedips] ADD 
	CONSTRAINT [FK_bannedips_site] FOREIGN KEY 
	(
		[site_id]
	) REFERENCES [dbo].[site] (
		[site_id]
	)

ALTER TABLE [dbo].[bannedlogins] ADD 
	CONSTRAINT [FK_bannedlogins_site] FOREIGN KEY 
	(
		[site_id]
	) REFERENCES [dbo].[site] (
		[site_id]
	)

ALTER TABLE [dbo].[restrictednames] ADD 
	CONSTRAINT [FK_restrictednames_site] FOREIGN KEY 
	(
		[site_id]
	) REFERENCES [dbo].[site] (
		[site_id]
	)

ALTER TABLE [dbo].[room] ADD 
	CONSTRAINT [FK_room_site] FOREIGN KEY 
	(
		[site_id]
	) REFERENCES [dbo].[site] (
		[site_id]
	)

ALTER TABLE [dbo].[storedmessages] ADD 
	CONSTRAINT [FK_storedmessages_site] FOREIGN KEY 
	(
		[site_id]
	) REFERENCES [dbo].[site] (
		[site_id]
	)

ALTER TABLE [dbo].[urlpatterns] ADD 
	CONSTRAINT [FK_urlpatterns_site] FOREIGN KEY 
	(
		[site_id]
	) REFERENCES [dbo].[site] (
		[site_id]
	)

*/
SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/* 
 * PROCEDURE: zbc_chat_get 
 */
CREATE PROCEDURE zbc_chat_get
AS
BEGIN
    SELECT *
      FROM zbc_chat

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_config_get 
 */
CREATE PROCEDURE zbc_config_get
AS
BEGIN
    SELECT *
      FROM zbc_config

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_config_update 
 */
CREATE PROCEDURE zbc_config_update
(
    @config_name      varchar(250),
    @config_value     varchar(255)            = NULL)
AS
BEGIN
    BEGIN TRAN

    UPDATE zbc_config
       SET config_value      = @config_value
     WHERE config_name = @config_name

    IF (@@error!=0)
    BEGIN
        RAISERROR  20001 'zbc_config_update: Cannot update  in config '
        ROLLBACK TRAN
        RETURN(1)
    
    END

    COMMIT TRAN

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_messages_delete
 */
CREATE PROCEDURE zbc_messages_delete
	@MessageDate datetime
AS
DELETE FROM zbc_msg
WHERE msg_date<=@MessageDate;
GO

/* 
 * PROCEDURE: zbc_site_delete 
 */
CREATE PROCEDURE zbc_site_delete
    @site_id int
AS
BEGIN
    BEGIN TRAN

    DELETE FROM zbc_site
     WHERE site_id = @site_id

    IF (@@error!=0)
    BEGIN
        RAISERROR  20002 'zbc_site_delete: Cannot delete because foreign keys still exist in site '
        ROLLBACK TRAN
        RETURN(1)
    END

    COMMIT TRAN
    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_site_get 
 */
CREATE PROCEDURE zbc_site_get
    @site_id int
AS
BEGIN
    SELECT *
      FROM zbc_site
     WHERE site_id = @site_id
    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_site_insert 
 */
CREATE PROCEDURE zbc_site_insert
(
    @site_id                   int,
    @site_name                 varchar(50)            = NULL,
    @MaxNumberOfUsers          int                    = NULL,
    @MaxNumberOfUsersRooms     int                    = NULL,
    @MaxNumberOfRooms          int                    = NULL,
    @MaxRoomNameLength         int                    = NULL,
    @MinMsgInterval            int                    = NULL,
    @HTTPPattern               varchar(255)            = NULL,
    @Flags			           int                    = NULL)
AS
BEGIN
    BEGIN TRAN

    INSERT INTO zbc_site(site_id,
                     site_name,
                     MaxNumberOfUsers,
                     MaxNumberOfRooms,
                     MaxRoomNameLength,
                     MinMsgInterval,
                     MaxNumberOfUsersRooms,
                     HTTPPattern,
                     Flags)
    VALUES(@site_id,
           @site_name,
           @MaxNumberOfUsers,
           @MaxNumberOfRooms,
           @MaxRoomNameLength,
           @MinMsgInterval,
           @MaxNumberOfUsersRooms,
           @HTTPPattern,
           @Flags)

    IF (@@error!=0)
    BEGIN
        RAISERROR  20000 'zbc_site_insert: Cannot insert because primary key value not found in site '
        ROLLBACK TRAN
        RETURN(1)
    
    END

    COMMIT TRAN
END
GO

/* 
 * PROCEDURE: zbc_site_update 
 */
CREATE PROCEDURE zbc_site_update
(
    @site_id                   int,
    @site_name                 varchar(50)            = NULL,
    @MaxNumberOfUsers          int                    = NULL,
    @MaxNumberOfUsersRooms     int                    = NULL,
    @MaxNumberOfRooms          int                    = NULL,
    @MaxRoomNameLength         int                    = NULL,
    @MinMsgInterval            int                    = NULL,
    @HTTPPattern               varchar(255)            = NULL,
    @Flags			           int                    = NULL)
AS
BEGIN
    BEGIN TRAN

    UPDATE zbc_site
       SET site_name                  = @site_name,
           MaxNumberOfUsers           = @MaxNumberOfUsers,
           MaxNumberOfRooms           = @MaxNumberOfRooms,
           MaxRoomNameLength          = @MaxRoomNameLength,
           MinMsgInterval             = @MinMsgInterval,
           MaxNumberOfUsersRooms      = @MaxNumberOfUsersRooms,
           HTTPPattern				  = @HTTPPattern,
           Flags					  = @Flags
     WHERE site_id = @site_id

    IF (@@error!=0)
    BEGIN
        RAISERROR  20001 'zbc_site_update: Cannot update  in site '
        ROLLBACK TRAN
        RETURN(1)
    END

    COMMIT TRAN
    RETURN(0)
END
GO


/* 
 * PROCEDURE: zbc_sites_get 
 */
CREATE PROCEDURE zbc_sites_get
AS
BEGIN
    SELECT *
      FROM zbc_site
     
    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_siteusers_get 
 */
CREATE PROCEDURE zbc_siteusers_get
(
    	@site_id           int,
	@user_type int = 1
)
AS
BEGIN
  SELECT *
	FROM zbc_user
	WHERE user_type = @user_type
	AND site_id  = @site_id
  RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_user_delete 
 */
CREATE PROCEDURE zbc_user_delete
(
    @login_id          varchar(50),
    @site_id           int)
AS
BEGIN
    BEGIN TRAN

    DELETE
      FROM zbc_user
     WHERE login_id = @login_id
       AND site_id  = @site_id

    IF (@@error!=0)
    BEGIN
        RAISERROR  20002 'zbc_user_delete: Cannot delete because foreign keys still exist in user '
        ROLLBACK TRAN
        RETURN(1)
    
    END

    COMMIT TRAN
    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_user_get 
 */
CREATE PROCEDURE zbc_user_get
(
    @login_id          varchar(50),
    @site_id           int)
AS
BEGIN
    SELECT *
      FROM zbc_user
     WHERE login_id = @login_id
       AND site_id  = @site_id

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_user_insert 
 */
CREATE PROCEDURE zbc_user_insert
(
    @login_id          varchar(50),
    @login_psw         varchar(50)            = NULL,
    @user_type		   int                    = NULL,
    @fname             varchar(50)            = NULL,
    @lname             varchar(50)            = NULL,
    @address           varchar(250)            = NULL,
    @email             varchar(80)            = NULL,
    @age               int                    = NULL,
    @allow_profile     bit                    = NULL,
    @gender			   char(1)				  = NULL,
    @custom			   varchar(255)            = NULL,
    @site_id           int
   
)
AS
BEGIN
    BEGIN TRAN

    INSERT INTO zbc_user(login_id,
                     site_id,
                     login_psw,
                     fname,
                     lname,
                     email,
                     address,
                     age,
                     user_type,
                     allow_profile,
                     gender,
                     custom)
    VALUES(@login_id,
           @site_id,
           @login_psw,
           @fname,
           @lname,
           @email,
           @address,
           @age,
           @user_type,
           @allow_profile,
           @gender,
           @custom)

    IF (@@error!=0)
    BEGIN
        RAISERROR  20000 'zbc_user_insert: Cannot insert because primary key value not found in user '
        ROLLBACK TRAN
        RETURN(1)
    
    END

    COMMIT TRAN
END
GO

/* 
 * PROCEDURE: zbc_user_update 
 */
CREATE PROCEDURE zbc_user_update
(
    @login_id          varchar(50),
    @login_psw         varchar(50)            = NULL,
    @user_type		   int                    = NULL,
    @fname             varchar(50)            = NULL,
    @lname             varchar(50)            = NULL,
    @address           varchar(250)            = NULL,
    @email             varchar(80)            = NULL,
    @age               int                    = NULL,
    @allow_profile     bit                    = NULL,
    @gender			   char(1)				  = NULL,
    @custom             varchar(255)            = NULL,
    @site_id           int
 )
AS
BEGIN
    BEGIN TRAN

    UPDATE zbc_user
       SET login_psw          = @login_psw,
           fname              = @fname,
           lname              = @lname,
           email              = @email,
           address            = @address,
           age                = @age,
           user_type		  = @user_type,
           allow_profile      = @allow_profile,
           gender			  = @gender,
           custom			  = @custom
     WHERE login_id = @login_id
       AND site_id  = @site_id

    IF (@@error!=0)
    BEGIN
        RAISERROR  20001 'zbc_user_update: Cannot update  in user '
        ROLLBACK TRAN
        RETURN(1)
    
    END

    COMMIT TRAN
    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_abusivewords_delete 
 */
CREATE PROCEDURE zbc_abusivewords_delete
(
    @site_id      int)
AS
BEGIN
    BEGIN TRAN

    DELETE
      FROM zbc_abusivewords
     WHERE site_id  = @site_id

    IF (@@error!=0)
    BEGIN
        RAISERROR  20002 'zbc_abusivewords_delete: Cannot delete because foreign keys still exist in abusivewords '
        ROLLBACK TRAN
        RETURN(1)
    
    END

    COMMIT TRAN

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_abusivewords_get 
 */
CREATE PROCEDURE zbc_abusivewords_get
(
    @word     varchar(50),
    @site_id      int)
AS
BEGIN
    SELECT *
      FROM zbc_abusivewords
     WHERE word = @word
       AND site_id  = @site_id

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_abusivewords_insert 
 */
CREATE PROCEDURE zbc_abusivewords_insert
(
    @word        varchar(50)            = NULL,
    @site_id     int                    = NULL)
AS
BEGIN
    BEGIN TRAN

    INSERT INTO zbc_abusivewords(word,
                             site_id)
    VALUES(@word,
           @site_id)

    IF (@@error!=0)
    BEGIN
        RAISERROR  20000 'zbc_abusivewords_insert: Cannot insert because primary key value not found in abusivewords '
        ROLLBACK TRAN
        RETURN(1)
    
    END
    COMMIT TRAN
END
GO

/* 
 * PROCEDURE: zbc_abusivewords_update 
 */
CREATE PROCEDURE zbc_abusivewords_update
(
    @word     varchar(50),
    @site_id      int)
AS
BEGIN
    UPDATE zbc_abusivewords
       SET word = @word
     WHERE word = @word
       AND site_id  = @site_id

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_abusivewordsall_get 
 */
CREATE PROCEDURE zbc_abusivewordsall_get
(
    @site_id      int)
AS
BEGIN
    SELECT *
      FROM zbc_abusivewords
     WHERE site_id  = @site_id

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_bannedips_delete 
 */
CREATE PROCEDURE zbc_bannedips_delete
(
    @site_id      int)
AS
BEGIN
    BEGIN TRAN

    DELETE
      FROM zbc_bannedips
     WHERE site_id  = @site_id

    IF (@@error!=0)
    BEGIN
        RAISERROR  20002 'zbc_bannedips_delete: Cannot delete because foreign keys still exist in bannedips '
        ROLLBACK TRAN
        RETURN(1)
    
    END

    COMMIT TRAN
    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_bannedips_get 
 */
CREATE PROCEDURE zbc_bannedips_get
(
    @bannedip     varchar(50),
    @site_id      int)
AS
BEGIN
    SELECT *
      FROM zbc_bannedips
     WHERE bannedip = @bannedip
       AND site_id  = @site_id

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_bannedips_insert 
 */
CREATE PROCEDURE zbc_bannedips_insert
(
    @bannedip     varchar(50),
    @site_id      int)
AS
BEGIN
    BEGIN TRAN

    INSERT INTO zbc_bannedips(bannedip,
                          site_id)
    VALUES(@bannedip,
           @site_id)

    IF (@@error!=0)
    BEGIN
        RAISERROR  20000 'zbc_bannedips_insert: Cannot insert because primary key value not found in bannedips '
        ROLLBACK TRAN
        RETURN(1)
    
    END

    COMMIT TRAN
END
GO

/* 
 * PROCEDURE: zbc_bannedips_update 
 */
CREATE PROCEDURE zbc_bannedips_update
(
    @bannedip     varchar(50),
    @site_id      int
)
AS
BEGIN
    UPDATE zbc_bannedips
       SET bannedip = @bannedip
     WHERE bannedip = @bannedip
       AND site_id  = @site_id
    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_bannedipsall_get 
 */
CREATE PROCEDURE zbc_bannedipsall_get
(
	@site_id      int
)
AS
BEGIN
    SELECT *
      FROM zbc_bannedips
		WHERE site_id  = @site_id
    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_bannedlogins_delete 
 */
CREATE PROCEDURE zbc_bannedlogins_delete
(
    @site_id         int)
AS
BEGIN
    BEGIN TRAN

    DELETE
      FROM zbc_bannedlogins
     WHERE site_id     = @site_id

    IF (@@error!=0)
    BEGIN
        RAISERROR  20002 'zbc_bannedlogins_delete: Cannot delete because foreign keys still exist in bannedlogins '
        ROLLBACK TRAN
        RETURN(1)
    
    END

    COMMIT TRAN

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_bannedlogins_get 
 */
CREATE PROCEDURE zbc_bannedlogins_get
(
    @bannedlogin     varchar(50),
    @site_id         int)
AS
BEGIN
    SELECT *
      FROM zbc_bannedlogins
     WHERE bannedlogin = @bannedlogin
       AND site_id     = @site_id

    RETURN(0)
END
GO


/* 
 * PROCEDURE: zbc_bannedlogins_insert 
 */
CREATE PROCEDURE zbc_bannedlogins_insert
(
    @bannedlogin     varchar(50),
    @site_id         int)
AS
BEGIN
    BEGIN TRAN

    INSERT INTO zbc_bannedlogins(bannedlogin,
                             site_id)
    VALUES(@bannedlogin,
           @site_id)

    IF (@@error!=0)
    BEGIN
        RAISERROR  20000 'zbc_bannedlogins_insert: Cannot insert because primary key value not found in bannedlogins '
        ROLLBACK TRAN
        RETURN(1)
    
    END
    COMMIT TRAN
END
GO


/* 
 * PROCEDURE: zbc_bannedlogins_update 
 */
CREATE PROCEDURE zbc_bannedlogins_update
(
    @bannedlogin     varchar(50),
    @site_id      int)
AS
BEGIN
    UPDATE zbc_bannedlogins
       SET bannedlogin = @bannedlogin
     WHERE bannedlogin = @bannedlogin
       AND site_id  = @site_id

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_bannedloginsall_get 
 */
CREATE PROCEDURE zbc_bannedloginsall_get
(
	@site_id      int)
AS
BEGIN
    SELECT *
      FROM zbc_bannedlogins
     WHERE site_id  = @site_id
    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_restrictednames_delete 
 */
CREATE PROCEDURE zbc_restrictednames_delete
(
    @site_id     int)
AS
BEGIN
    BEGIN TRAN

    DELETE
      FROM zbc_restrictednames
     WHERE site_id = @site_id

    IF (@@error!=0)
    BEGIN
        RAISERROR  20002 'zbc_restrictednames_delete: Cannot delete because foreign keys still exist in restrictednames '
        ROLLBACK TRAN
        RETURN(1)
    
    END

    COMMIT TRAN
    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_restrictednames_get 
 */
CREATE PROCEDURE zbc_restrictednames_get
(
    @word        varchar(50),
    @site_id     int)
AS
BEGIN
    SELECT *
      FROM zbc_restrictednames
     WHERE word    = @word
       AND site_id = @site_id

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_restrictednames_insert 
 */
CREATE PROCEDURE zbc_restrictednames_insert
(
    @word        varchar(50),
    @site_id     int)
AS
BEGIN
    BEGIN TRAN

    INSERT INTO zbc_restrictednames(word,
                                site_id)
    VALUES(@word,
           @site_id)

    IF (@@error!=0)
    BEGIN
        RAISERROR  20000 'zbc_restrictednames_insert: Cannot insert because primary key value not found in restrictednames '
        ROLLBACK TRAN
        RETURN(1)
    
    END
    COMMIT TRAN
END
GO

/* 
 * PROCEDURE: zbc_restrictednames_update 
 */
CREATE PROCEDURE zbc_restrictednames_update
(
    @restrictedname     varchar(50),
    @site_id      int)
AS
BEGIN
    UPDATE zbc_restrictednames
       SET word = @restrictedname
     WHERE word = @restrictedname
       AND site_id  = @site_id

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_restrictednamesall_get 
 */
CREATE PROCEDURE zbc_restrictednamesall_get(
	@site_id      int)
AS
BEGIN
    SELECT *
      FROM zbc_restrictednames
     WHERE site_id  = @site_id
    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_room_delete 
 */
CREATE PROCEDURE zbc_room_delete
(
    @room_id        int)
AS
BEGIN
    BEGIN TRAN

    DELETE
      FROM zbc_room
     WHERE room_id = @room_id

    IF (@@error!=0)
    BEGIN
        RAISERROR  20002 'zbc_room_delete: Cannot delete because foreign keys still exist in room '
        ROLLBACK TRAN
        RETURN(1)
    
    END

    COMMIT TRAN

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_room_get 
 */
CREATE PROCEDURE zbc_room_get
(
    @room_id        int,
    @site_id        int)
AS
BEGIN
    SELECT *
      FROM zbc_room
     WHERE room_id = @room_id
     AND site_id = @site_id

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_messages_insert 
 */
CREATE PROCEDURE zbc_messages_insert
(
	@site_id        int                    = NULL,
	@site_name      varchar(50)            = NULL,
    @room_id        int                    = NULL,
    @room_name      varchar(50)            = NULL,
    @from_user      varchar(50),
    @to_user        varchar(50)            = NULL,
    @msg_text       text,
    @msg_date       datetime,
    @from_ip		varchar(64) = NULL
    )
AS
BEGIN
    BEGIN TRAN

    INSERT INTO zbc_msg (site_id, 
					site_name, 
					room_id, 
					room_name, 
					from_user, 
					to_user, 
					msg_text, 
					msg_date,
					from_ip)
					
	VALUES (		@site_id, 
					@site_name, 
					@room_id, 
					@room_name, 
					@from_user, 
					@to_user, 
					@msg_text, 
					@msg_date,
					@from_ip)
					
    IF (@@error!=0)
    BEGIN
        RAISERROR  20000 'zbc_messages_insert: Cannot insert because primary key value not found in msg '
        ROLLBACK TRAN
        RETURN(1)
    
    END
    COMMIT TRAN
END
GO


/* 
 * PROCEDURE: zbc_room_insert 
 */
CREATE PROCEDURE zbc_room_insert
(
    @room_id        int,
    @room_name      varchar(80),
    @room_topic     varchar(255)            = NULL,
    @private        bit                    = NULL,
    @moderator      bit                    = NULL,
    @room_owner     varchar(50),
    @site_id        int                    = NULL)
AS
BEGIN
    BEGIN TRAN

    INSERT INTO zbc_room(room_id,
                     room_name,
                     room_topic,
                     room_owner,
                     private,
                     moderator,
                     site_id)
    VALUES(@room_id,
           @room_name,
           @room_topic,
           @room_owner,
           @private,
           @moderator,
           @site_id)

    IF (@@error!=0)
    BEGIN
        RAISERROR  20000 'zbc_room_insert: Cannot insert because primary key value not found in room '
        ROLLBACK TRAN
        RETURN(1)
    
    END

    COMMIT TRAN
END
GO

/* 
 * PROCEDURE: zbc_room_update 
 */
CREATE PROCEDURE zbc_room_update
(
    @room_id        int,
    @room_name      varchar(80),
    @room_topic     varchar(255)            = NULL,
    @private        bit                    = NULL,
    @moderator      bit                    = NULL,
    @room_owner     varchar(50),
    @site_id        int                    = NULL)
AS
BEGIN
    BEGIN TRAN

    UPDATE zbc_room
       SET room_name       = @room_name,
           room_topic      = @room_topic,
           room_owner      = @room_owner,
           private         = @private,
           moderator       = @moderator
     WHERE room_id = @room_id
     AND site_id         = @site_id

    IF (@@error!=0)
    BEGIN
        RAISERROR  20001 'zbc_room_update: Cannot update  in room '
        ROLLBACK TRAN
        RETURN(1)
    
    END

    COMMIT TRAN
    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_siterooms_get 
 */
CREATE PROCEDURE zbc_siterooms_get
(
    @site_id        int)
AS
BEGIN
    SELECT *
      FROM zbc_room
     WHERE site_id = @site_id

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_storedmessages_delete 
 */
CREATE PROCEDURE zbc_storedmessages_delete
(
    @site_id     int)
AS
BEGIN
    BEGIN TRAN

    DELETE
      FROM zbc_storedmessages
     WHERE site_id = @site_id

    IF (@@error!=0)
    BEGIN
        RAISERROR  20002 'zbc_storedmessages_delete: Cannot delete because foreign keys still exist in storedmessages '
        ROLLBACK TRAN
        RETURN(1)
    
    END

    COMMIT TRAN

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_storedmessages_get 
 */
CREATE PROCEDURE zbc_storedmessages_get
(
    @message     varchar(50),
    @site_id     int)
AS
BEGIN
    SELECT *
      FROM zbc_storedmessages
     WHERE msg = @message
       AND site_id = @site_id

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_storedmessages_insert 
 */
CREATE PROCEDURE zbc_storedmessages_insert
(
    @message     varchar(50),
    @site_id     int)
AS
BEGIN
    BEGIN TRAN

    INSERT INTO zbc_storedmessages(msg,
                               site_id)
    VALUES(@message,
           @site_id)

    IF (@@error!=0)
    BEGIN
        RAISERROR  20000 'zbc_storedmessages_insert: Cannot insert because primary key value not found in storedmessages '
        ROLLBACK TRAN
        RETURN(1)
    
    END

    COMMIT TRAN
END
GO

/* 
 * PROCEDURE: zbc_storedmessages_update 
 */
CREATE PROCEDURE zbc_storedmessages_update(
    @bannedlogin     varchar(50),
    @site_id      int
)
AS
BEGIN
    UPDATE zbc_bannedlogins
       SET bannedlogin = @bannedlogin     
     WHERE bannedlogin = @bannedlogin     
       AND site_id  = @site_id

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_storedmessagesall_get 
 */
CREATE PROCEDURE zbc_storedmessagesall_get
(
	@site_id      int
)
AS
BEGIN
    SELECT *
      FROM zbc_storedmessages
     WHERE site_id  = @site_id
    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_urlpatterns_delete 
 */
CREATE PROCEDURE zbc_urlpatterns_delete
(
    @site_id     int)
AS
BEGIN
    BEGIN TRAN

    DELETE
      FROM zbc_urlpatterns
     WHERE site_id = @site_id

    IF (@@error!=0)
    BEGIN
        RAISERROR  20002 'zbc_urlpatterns_delete: Cannot delete because foreign keys still exist in urlpatterns '
        ROLLBACK TRAN
        RETURN(1)
    END

    COMMIT TRAN
    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_urlpatterns_get 
 */
CREATE PROCEDURE zbc_urlpatterns_get
(
    @pattern     varchar(50),
    @site_id     int)
AS
BEGIN
    SELECT *
      FROM zbc_urlpatterns
     WHERE pattern = @pattern
       AND site_id = @site_id

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_urlpatterns_insert 
 */
CREATE PROCEDURE zbc_urlpatterns_insert
(
    @pattern     varchar(50),
    @site_id     int)
AS
BEGIN
    BEGIN TRAN

    INSERT INTO zbc_urlpatterns(pattern,
                            site_id)
    VALUES(@pattern,
           @site_id)

    IF (@@error!=0)
    BEGIN
        RAISERROR  20000 'zbc_urlpatterns_insert: Cannot insert because primary key value not found in urlpatterns '
        ROLLBACK TRAN
        RETURN(1)
    END

    COMMIT TRAN
END
GO

/* 
 * PROCEDURE: zbc_urlpatterns_update 
 */
CREATE PROCEDURE zbc_urlpatterns_update
(
    @pattern     varchar(50),
    @site_id      int
)
AS
BEGIN
    UPDATE zbc_urlpatterns
       SET pattern = @pattern     
     WHERE pattern = @pattern     
       AND site_id  = @site_id

    RETURN(0)
END
GO

/* 
 * PROCEDURE: zbc_urlpatternsall_get 
 */
CREATE PROCEDURE zbc_urlpatternsall_get
(
    @site_id      int
)
AS
BEGIN
    SELECT *
      FROM zbc_urlpatterns
     WHERE site_id  = @site_id
    RETURN(0)
END
GO


CREATE PROCEDURE transcript_get
(
	@site_id int,
	@start_date datetime,
	@end_date datetime
)
AS
	SELECT msg_date,room_name,from_user,to_user,msg_text
	FROM zbc_msg 
	where site_id=@site_id
	and msg_date>=@start_date
	and msg_date<=@end_date
	order by room_id, msg_date
GO
