alter table zbc_msg
add from_ip varchar(64) COLLATE SQL_Latin1_General_CP1_CI_AS

drop procedure zbc_messages_insert

CREATE PROCEDURE zbc_messages_insert
(
	@site_id        int                    = NULL,
	@site_name      varchar(50)            = NULL,
	@room_id        int                    = NULL,
	@room_name      varchar(50)            = NULL,
	@from_user      varchar(50),
	@to_user        varchar(50)            = NULL,
	@msg_text       text,
	@msg_date       datetime,
	@from_ip		varchar(64) = NULL
)
AS
BEGIN
    BEGIN TRAN

    INSERT INTO zbc_msg (site_id, 
					site_name, 
					room_id, 
					room_name, 
					from_user, 
					to_user, 
					msg_text, 
					msg_date,
					from_ip)
					
	VALUES (		@site_id, 
					@site_name, 
					@room_id, 
					@room_name, 
					@from_user, 
					@to_user, 
					@msg_text, 
					@msg_date,
					@from_ip)
					
    IF (@@error!=0)
    BEGIN
        RAISERROR  20000 'zbc_messages_insert: Cannot insert because primary key value not found in msg '
        ROLLBACK TRAN
        RETURN(1)
    
    END
    COMMIT TRAN
END
GO